<cmps_info_explorer>
    <!-- Subnavbar -->
    <div class="subnavbar" style="background: #171717; position: relative;">
        <div class="subnavbar-inner">
            <!-- Subnavbar content, for example tabs buttons -->
            <div class="segmented">
                <div><a data-popover=".currency-popover" class="button popover-open">{currentCurrency.currency}</a></div>
                <div class="item-input-wrap" style="width:100%; height:100%; padding-left: 5px;">
                    <input id="explorerAddress" type="text" placeholder="62cbe6721b0198bf92d2244b36303feaf1336f16" style="width: 100%;line-height: 36px;font-size: 14px;">
                </div>
                <a href="#" class="button" onclick="{search}"><i1-8n>查詢</i1-8n></a>
                <div style="line-height: 36px;font-size: 14px;">{numeral((Math.floor(credit*100))*0.01).format("0,0.00")}</div>
            </div>
        </div>
    </div>
    <div class="popover currency-popover">
        <div class="popover-inner">
            <!-- Link to close popover -->
            <div class="list">
                <ul>
                    <li each="{currency in currencies}" if="{currency.show_for_explorer}"><a class="list-button item-link" href="#" onclick="{setCurrency}">{currency.currency}</a></li>
                </ul>
            </div>
        </div>
    </div>
    <div class="data-table">
        <table>
            <thead>
                <tr>
                    <th><i1-8n>時間</i1-8n></th>
                    <th class="numeric-cell">
                        <i1-8n>金額</i1-8n>
                    </th>
                    <th class="numeric-cell"><i1-8n>手續費</i1-8n></th>
                    <th class="tablet-only"><i1-8n>位址</i1-8n></th>
                </tr>
            </thead>
            <tbody>
                <tr each="{transfer in transactions}" onclick="{showDetail}" style="cursor: pointer;">
                    <td>{moment.unix(transfer.timeStamp).format("YYYY-MM-DD")}</td>
                    <td class="numeric-cell" if="{transfer.direct}">+{numeral(transfer.amount).format("0,0.000")}</td>
                    <td class="numeric-cell" if="{!transfer.direct}">-{numeral(transfer.amount).format("0,0.000")}</td>
                    <td class="numeric-cell">{numeral(transfer.gasUsed).format("0,0.000")}</td>
                    <td class="tablet-only" if={transfer.direct}><tt>{transfer.from}</tt></td>
                    <td class="tablet-only" if={!transfer.direct}><tt>{transfer.to}</tt></td>
                </tr>
            </tbody>
        </table>
    </div>
    <script>
        var cmp = this;
        cmp.name = "cmps_info_explorer";
        cmp.credit = 0;
        cmp.transactions = [];
        cmp.currencies = [];
        
        cmp.on('mount',function(){
			jApp.cmpReg[cmp.name] = this;
            cmp.loadData();
        });
        cmp.loadData = function(){
            $.get(API_ENDPOINT+"/exchange_rates", function(data){
                console.log(data);
                cmp.currencies = data;
                for ( var i = 0 ; i < data.length ; ++i ){
                    if (cmp.currencies[i].currency=="SUP")
                        cmp.currentCurrency = cmp.currencies[i];
                }
                
                cmp.update();
            });
        }
        cmp.search = function(){
            $.get(API_ENDPOINT+"/wallet/balance/"+$("#explorerAddress").val()+"/"+cmp.currentCurrency.currency, function(data){
                var rate = 0.000000000000000001;
                cmp.credit = data.credit * rate;
                cmp.update();
            });
            $.get(API_ENDPOINT+"/wallet/transaction/explorer/"+$("#explorerAddress").val()+"/"+cmp.currentCurrency.currency, function(data){
                if ( data.transactions.length == 0 ){
                    app.dialog.alert("No Transaction Data", "Search Result");
                }
                cmp.transactions = data.transactions.reverse();
                cmp.address = "0x"+data.address.replace("0x","").toLowerCase();
                cmp.ignore = data.ignore.replace("0x","").toLowerCase();
                for ( var i = 0 ; i < cmp.transactions.length ; ++i ){

                    if (cmp.transactions[i].from.toLowerCase() == cmp.address){
                        cmp.transactions[i].direct = false;
                    }else{
                        cmp.transactions[i].direct = true;
                    }
                    var rate = 1;
                    if ( cmp.transactions[i].value > 100000000000 ){
                        rate = 0.000000000000000001;
                        cmp.transactions[i].gasUsed = cmp.transactions[i].gas * cmp.transactions[i].gasPrice * rate;
                    }
                    cmp.transactions[i].amount = cmp.transactions[i].value * rate;
//                    console.log(cmp.transactions[i].from, cmp.transactions[i].to, cmp.address, cmp.transactions[i].direct);
                }
                cmp.transactions = cmp.transactions.sort(function(a,b){
                    return b.timeStamp*1 - a.timeStamp*1;
                });
                cmp.update();
            });
        }
        cmp.showDetail = function(e){
            var trx = e.item.transfer;
            if ( trx.direct ){
                $("#explorerAddress").val(trx.from);
            }else{
                $("#explorerAddress").val(trx.to);
            }
            cmp.search();
        }
        cmp.setCurrency = function(e){
            cmp.currentCurrency = e.item.currency;
            app.popover.close(".currency-popover");
            cmp.update();
        }
    </script>
</cmps_info_explorer>
